package de.szut.lf8_starter.project.utils;

import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.ResponseEntity;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;

public interface AuthenticationHelper {

    default String getAuthenticationToken(TestRestTemplate restTemplate) {
        MultiValueMap<String, String> authParams = new LinkedMultiValueMap<>();
        authParams.add("grant_type", "password");
        authParams.add("client_id", "employee-management-service");
        authParams.add("username", "user");
        authParams.add("password", "test");

        HttpHeaders headers = new HttpHeaders();
        headers.set("Content-Type", "application/x-www-form-urlencoded");

        HttpEntity<MultiValueMap<String, String>> request = new HttpEntity<>(authParams, headers);
        ResponseEntity<String> authResponse = restTemplate.postForEntity("https://keycloak.szut.dev/auth/realms/szut/protocol/openid-connect/token", request, String.class);

        // Extract the token from the response
        String responseBody = authResponse.getBody();
        assert responseBody != null;

        return "Bearer " + extractToken(responseBody);
    }

    private String extractToken(String responseBody) {
        return responseBody.substring(responseBody.indexOf("access_token\":\"") + 15, responseBody.indexOf("\"", responseBody.indexOf("access_token\":\"") + 15));
    }
}